
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java线程Dump分析工具--jstack（转） / iVAN</title>

    <meta name="description" content="Java线程Dump分析工具--jstack（转） jstack用于打印出给定的java进程ID或core file或远程调试服务的Java堆栈信息,如果是在64位机器上,需要指定选项&quot;-J-d64&quot;,Windows的jstack使用方式只支持以下的这种方式:     jstack [-l][F] pid     如果java程序崩溃生成core文件,jstack工具可以用来获得core文件的java stack和native stack的信息,从而可以轻松地知道java程序是如何崩溃和在程序何处发生问题.另外,jstack工 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java线程Dump分析工具--jstack（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>　jstack</strong>用于打印出给定的java进程ID或core file或远程调试服务的Java堆栈信息，如果是在64位机器上，需要指定选项"-J-d64"，Windows的jstack使用方式只支持以下的这种方式：<br />     <strong><em>jstack [-l][F] pid</em></strong><br />     如果java程序崩溃生成core文件，jstack工具可以用来获得core文件的java stack和native stack的信息，从而可以轻松地知道java程序是如何崩溃和在程序何处发生问题。另外，jstack工具还可以附属到正在运行的java程序中，看到当时运行的java程序的java stack和native stack的信息, 如果现在运行的java程序呈现hung的状态，jstack是非常有用的。进程处于hung死状态可以用-F强制打出stack。<br />     <strong>dump 文件里，值得关注的线程状态有：</strong><br />     死锁，<strong>Deadlock（重点关注）</strong><br />     执行中，Runnable  <br />     等待资源，<strong>Waiting on condition（重点关注）</strong><br />     等待获取监视器，<strong>Waiting on monitor entry（重点关注）</strong><br />     暂停，Suspended<br />     对象等待中，Object.wait() 或 TIMED_WAITING<br />     阻塞，<strong>Blocked（重点关注）</strong> <br />     停止，Parked</p>
<p>在摘了另一篇博客的三种场景：</p>
<p><strong>实例一：Waiting to lock 和 Blocked</strong></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>"RMI TCP Connection(267865)-172.16.5.25" daemon prio=10 tid=0x00007fd508371000 nid=0x55ae waiting for monitor entry [0x00007fd4f8684000]
   java.lang.Thread.State: BLOCKED (on object monitor)
at org.apache.log4j.Category.callAppenders(Category.java:201)
- waiting to lock &lt;0x00000000acf4d0c0&gt; (a org.apache.log4j.Logger)
at org.apache.log4j.Category.forcedLog(Category.java:388)
at org.apache.log4j.Category.log(Category.java:853)
at org.apache.commons.logging.impl.Log4JLogger.warn(Log4JLogger.java:234)
at com.tuan.core.common.lang.cache.remote.SpyMemcachedClient.get(SpyMemcachedClient.java:110)</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>说明：<br />1）线程状态是 Blocked，阻塞状态。说明线程等待资源超时！<br />2）“ waiting to lock &lt;0x00000000acf4d0c0&gt;”指，线程在等待给这个 0x00000000acf4d0c0 地址上锁（英文可描述为：trying to obtain  0x00000000acf4d0c0 lock）。<br />3）在 dump 日志里查找字符串 0x00000000acf4d0c0，发现有大量线程都在等待给这个地址上锁。如果能在日志里找到谁获得了这个锁（如locked &lt; 0x00000000acf4d0c0 &gt;），就可以顺藤摸瓜了。<br />4）“waiting for monitor entry”说明此线程通过 synchronized(obj) {……} 申请进入了临界区，从而进入了下图1中的“Entry Set”队列，但该 obj 对应的 monitor 被其他线程拥有，所以本线程在 Entry Set 队列中等待。<br />5）第一行里，"RMI TCP Connection(267865)-172.16.5.25"是 Thread Name 。tid指Java Thread id。nid指native线程的id。prio是线程优先级。[0x00007fd4f8684000]是线程栈起始地址。</p>
<p><strong>实例二：Waiting on condition 和 TIMED_WAITING</strong></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>"RMI TCP Connection(idle)" daemon prio=10 tid=0x00007fd50834e800 nid=0x56b2 waiting on condition [0x00007fd4f1a59000]
   java.lang.Thread.State: TIMED_WAITING (parking)
at sun.misc.Unsafe.park(Native Method)
- parking to wait for  &lt;0x00000000acd84de8&gt; (a java.util.concurrent.SynchronousQueue$TransferStack)
at java.util.concurrent.locks.LockSupport.parkNanos(LockSupport.java:198)
at java.util.concurrent.SynchronousQueue$TransferStack.awaitFulfill(SynchronousQueue.java:424)
at java.util.concurrent.SynchronousQueue$TransferStack.transfer(SynchronousQueue.java:323)
at java.util.concurrent.SynchronousQueue.poll(SynchronousQueue.java:874)
at java.util.concurrent.ThreadPoolExecutor.getTask(ThreadPoolExecutor.java:945)
at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:907)
at java.lang.Thread.run(Thread.java:662)</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p> </p>
<p>说明：</p>
<p>1）“TIMED_WAITING (parking)”中的 timed_waiting 指等待状态，但这里指定了时间，到达指定的时间后自动退出等待状态；parking指线程处于挂起中。</p>
<p>2）“waiting on condition”需要与堆栈中的“parking to wait for  &lt;0x00000000acd84de8&gt; (a java.util.concurrent.SynchronousQueue$TransferStack)”结合来看。首先，本线程肯定是在等待某个条件的发生，来把自己唤醒。其次，SynchronousQueue 并不是一个队列，只是线程之间移交信息的机制，当我们把一个元素放入到 SynchronousQueue 中时必须有另一个线程正在等待接受移交的任务，因此这就是本线程在等待的条件。<br />3）别的就看不出来了。</p>
<p><strong>实例三：in Obejct.wait() 和 TIMED_WAITING</strong></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>"RMI RenewClean-[172.16.5.19:28475]" daemon prio=10 tid=0x0000000041428800 nid=0xb09 in Object.wait() [0x00007f34f4bd0000]
   java.lang.Thread.State: TIMED_WAITING (on object monitor)
at java.lang.Object.wait(Native Method)
- waiting on &lt;0x00000000aa672478&gt; (a java.lang.ref.ReferenceQueue$Lock)
at java.lang.ref.ReferenceQueue.remove(ReferenceQueue.java:118)
- locked &lt;0x00000000aa672478&gt; (a java.lang.ref.ReferenceQueue$Lock)
at sun.rmi.transport.DGCClient$EndpointEntry$RenewCleanThread.run(DGCClient.java:516)
at java.lang.Thread.run(Thread.java:662)</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p>说明：</p>
<p>1）“TIMED_WAITING (on object monitor)”，对于本例而言，是因为本线程调用了 java.lang.Object.wait(long timeout) 而进入等待状态。</p>
<p>2）“Wait Set”中等待的线程状态就是“ in Object.wait() ”。当线程获得了 Monitor，进入了临界区之后，如果发现线程继续运行的条件没有满足，它则调用对象（一般就是被 synchronized 的对象）的 wait() 方法，放弃了 Monitor，进入 “Wait Set”队列。只有当别的线程在该对象上调用了 notify() 或者 notifyAll() ，“ Wait Set”队列中线程才得到机会去竞争，但是只有一个线程获得对象的 Monitor，恢复到运行态。</p>
<p>3）RMI RenewClean 是 DGCClient 的一部分。DGC 指的是 Distributed GC，即分布式垃圾回收。</p>
<p>4）请注意，是先 locked &lt;0x00000000aa672478&gt;，后 waiting on &lt;0x00000000aa672478&gt;，之所以先锁再等同一个对象，请看下面它的代码实现：<br />static private class  Lock { };<br />private Lock lock = new Lock();<br />public Reference&lt;? extends T&gt; remove(long timeout)<br />{<br />    synchronized (lock) {<br />        Reference&lt;? extends T&gt; r = reallyPoll();<br />        if (r != null) return r;<br />        for (;;) {<br />            lock.wait(timeout);<br />            r = reallyPoll();<br />            ……<br />       }<br />}<br />即，线程的执行中，先用 synchronized 获得了这个对象的 Monitor（对应于  locked &lt;0x00000000aa672478&gt; ）；当执行到 lock.wait(timeout);，线程就放弃了 Monitor 的所有权，进入“Wait Set”队列（对应于  waiting on &lt;0x00000000aa672478&gt; ）。<br />5）从堆栈信息看，是正在清理 remote references to remote objects ，引用的租约到了，分布式垃圾回收在逐一清理呢。</p>
<p>参考：</p>
<p>命令汇总：http://blog.csdn.net/fenglibing/article/details/6411940<br />三种实例：http://www.cnblogs.com/zhengyun_ustc/archive/2013/01/06/dumpanalysis.html</p>
<p>http://www.cnblogs.com/nexiyi/p/java_thread_jstack.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 16:44:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/thread/" title="thread">thread</a>, <a href="https://www.iamivan.net/tag/lock/" title="lock">lock</a>, <a href="https://www.iamivan.net/tag/dump/" title="dump">dump</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java线程Dump分析工具--jstack（转）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdEKL3z.html" rel="bookmark">jstack和线程dump分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jstack和线程dump分析 jstack定义: jstack是java虚拟机自带的一种堆栈跟踪工具. 基本介绍: jstack用于生成java虚拟机当前时刻的线程快照.线程快照是当前java虚拟机内每一条线程正在执行的方法堆栈的集合,生成线程快照的主要目的是定位线程出现长时间停顿的原因,如线程间死锁.死循环.请求外部资源导致的长时间等待等. 线程出现停顿的时候通过jstack来查看各个线程的调用堆栈,就可以知道没有响应的线程到底在后台做什么事情,或者等待什么资源. 命令格式: jstack			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj89E5p.html" rel="bookmark">java自带的工具Jstack截取进程中的堆栈信息&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Java软件的使用过程中,有时会莫名的出现奇怪的问题.而这些问题常常无法使用日志信息定位,这时我们就需要通过查看进程内部线程的堆栈调用关系来分析问题出在哪里. 举个例子,当我们在做某个操作时,莫名的会弹出多个警告框,其中有些信息是正常的,有些则不是.对于这些错误的警告信息,我们该如何定位是哪个位置的代码出现了错误弹出的框呢? 我们就需要在弹框以后,去查看软件的各个线程,去查找究竟是哪个线程导致了该问题.可是有时因为环境.时间等问题,我们根本不能拿着IDE去调试, 只能通过工具软件拍下内存快照,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My375Jz.html" rel="bookmark">Java开源运行分析工具&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  FProfiler  FProfiler是一个非常快的Java profiler.它利用BCEL和log4j来记录每个方法从开始到结尾的日记.FProfiler可以用来在你的应用程序,Servlet,Applet...中找出hotspots. 更多FProfiler信息   JRat  JRat是一个Java Runtime分析工具包.它的目的是让开发者更好的明白Java程序动行时的状态.JRat包括但并不只局限于性能剖析. 更多JRat信息   EJP  EJP(Extensible Ja			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKL2wWM.html" rel="bookmark">深入理解java虚拟机的故障处理工具&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 本文主要给大家介绍的是java虚拟机的故障处理工具,文中提到这些工具包括: 名称 主要作用 jps JVM process Status Tool, 显示指定系统内所有的HotSpot虚拟机进程.通常是本地主机 jstat JVM Statistics Monitoring Tool,用于收集HotSpot虚拟机各方面的运行数据 jinfo Configuration Info for java, 显示虚拟机配置信息 jmap Memory Map for Java, 生成虚拟机的内存存储			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeK5XjM.html" rel="bookmark">三个实例演示 Java Thread Dump 日志分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址: http://www.cnblogs.com/zhengyun_ustc/archive/2013/01/06/dumpanalysis.html jstack Dump 日志文件中的线程状态 dump 文件里,值得关注的线程状态有: 死锁,Deadlock(重点关注)  执行中,Runnable    等待资源,Waiting on condition(重点关注)  等待获取监视器,Waiting on monitor entry(重点关注) 暂停,Suspended 对象等待中,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6Vo6M.html" rel="bookmark">指针-java静态代码检查工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java静态代码检查工具 推荐一款java静态代码检查的工具,可以java nullpointer exception静态检查,可以实现检查是否有抛空指针异常的可能性,便于解决代码中更多空指针异常的问题 解决方案 FindBugs,这个可以检查很多,并且根据异常的等级区分开来. 解决方案二: 去这里 http://java-source.net/open-source/code-analyzers 选择 解决方案三: http://stackoverflow.com/questions			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyWP18z.html" rel="bookmark">输出java进程的jstack信息示例分享 通过线程堆栈信息分析java线程&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: #!/bin/shpro_name=java #process namekeys=`ps -ef |grep &quot;$pro_name&quot; |grep -v &quot;grep&quot; | awk '{print $2}'`nowdate=`date +%Y%m%d%H%M%S` jstackpath=&quot;/usr/java/jdk1.6.0_07/bin/jstack&quot;cpulogpath=&quot;/home/&quot; for key			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRdwEz.html" rel="bookmark">java线程僵死-jstack日志</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java线程僵死-jstack日志 2014-12-15 14:19:47 Full thread dump Java HotSpot(TM) 64-Bit Server VM (20.45-b01 mixed mode): &quot;resin-1954&quot; daemon prio=10 tid=0x00007fe870024800 nid=0x15ca waiting on condition [0x00007fe8ad969000] java.lang.Thread.State:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvra1NM.html" rel="bookmark">用Jstack跟踪Cpu占用率的Java线程（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下方法在centOS下执行通过:1.先定位占用cpu高的进程 top 2.使用以下命令 ps p 14766 -L -o pcpu,pid,tid,time,tname,stat,psr | sort -n -k1 -r 其中14766是刚才1中cpu占用率高的进程pid 3.2.4 32525 32537 01:58:41 ?        Sl     6 0.8 32525  1771 00:43:12 ?        Sl     0 0.8 32525  1769 00:39:46			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4L28z.html" rel="bookmark" class="title">Access使用查询--1&period;1&period; 用选择查询建立计算字段</a>
					<div>
						1. 用选择查询建立计算字段 建一个选择查询,添加&quot;车队运输&quot;表,将其所有字段拖拽到设计网格中.如图一所示,只要在空白列中填写&quot;净重:毛重-皮重&quot;,系统会自动为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3xy0M.html" rel="bookmark" class="title">从郑州seo排名讨论网址标准化</a>
					<div>
						郑州seo排名一直都是竞争蛮激烈的,至少是ybsong的博客从来没有到过首页,这正好显示了和站长助的 差距,因为他一下子占了首页2个位置!看看这个网站是如何用一个目录的2个页面占据百度第二三的位置的! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNBLWM.html" rel="bookmark" class="title">跟SEO超级外链不得不说的事</a>
					<div>
						超级外链:超级外链是集合类似Alexa排名查询,pr查询等站长常用查询网站,由于这些网站大多有查询记录显示功能,而且查询记录可以被百度,谷歌,搜狗等搜索引擎快速收录,这样就形成了外链.因为这是正常的查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Ao6qp.html" rel="bookmark" class="title">TypePerf收集服务器性能</a>
					<div>
						TypePerf.exe这个命令行工具可以收集服务器性能数据 --1.查找和数据库 JinRiDomesticOrder相关的性能参数 TYPEPERF -qx &quot;SQLServer:Dat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jA99b.html" rel="bookmark" class="title">windows server 2008 R2&sol;windows 7管理三十 防火墙TMG2010应用</a>
					<div>
						咱的TMG基本上工作正常了,这篇咱们试着在2008R2和win7这个环境玩玩,这个系列写到现在,咱们该有的貌似都有了,剩下的就是内外互通问题了.咱们这篇看看发布一些应用和设置策略瞧瞧tmg2010跟i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jd2xb.html" rel="bookmark" class="title">在SpringSide 3 中使用JCaptcha</a>
					<div>
						在目前的网络上,想必大家对验证图片已经司空见惯了.验证图片是区分人和计算机的一种既有效又简单的方法.为了提高网站的安全性,防止黑客利用计算机进行暴力破解和防止黑客使用程序自动提交大量垃圾信息,在我们的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3N08mz.html" rel="bookmark" class="title">Photoshop调出草地婚片蓝紫色 PS调色教程</a>
					<div>
						蓝紫色图片的素材选取较为重要,背景部分的颜色不要太复杂,这样可以用色相/饱和度等调色工具快速把背景色转为想要的基色,然后再微调整体及局部颜色即可. 原图 &lt;点小图查看大图&gt; 最终效果 &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBXAlb.html" rel="bookmark" class="title">PowerPoint2013如何插入图片</a>
					<div>
						  1.切换至要插入图片的幻灯片. 2.单击&quot;插入&quot;选项卡中的&quot;图像&quot;组中的&quot;图片&quot;菜单. 3.在弹出的&quot;插入图片&quot;对话 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eQRXb.html" rel="bookmark" class="title">win7网络连接不上怎么办</a>
					<div>
						  win7系统的网络连接其实是非常方便的,就在右下角打开菜单即可选择网络连接,那么我们有时候连不上网络怎么办呢?系统之家小编给出大家几种常见的解决办法.仅针对线网络. 方法/步骤 1.首先看一下右下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3jAAM.html" rel="bookmark" class="title">【整理】MySQL 之 日志</a>
					<div>
						MySQL 中的各种日志文件  1. 错误日志 --log-error[=file_name]       错误日志记录了 mysql server 运行过程中所有较为严重的警告和错误信息,以及 my ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3Rvvp.html" rel="bookmark" class="title">解析Cloudera Manager内部结构、功能包括配置文件、目录位置等</a>
					<div>
						1. 相关目录 /var/log/cloudera-scm-installer : 安装日志目录. /var/log/* : 相关日志文件(相关服务的及CM的). /usr/share/cmf/ :  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7QB2z.html" rel="bookmark" class="title">What&rsquo;s popular的交叉验证模式</a>
					<div>
						郑昀 20090919 有很多利用了群众性智慧的机器智能系统是回答 What's popular 这个问题的,比如: 阅读(Reading)领域: techmeme tweetmeme stumble ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvrv4WM.html" rel="bookmark" class="title">独家 &vert; 手把手教随机森林</a>
					<div>
						随机森林-概述   当变量的数量非常庞大时,你将采取什么方法来处理数据?   通常情况下,当问题非常庞杂时,我们需要一群专家而不是一个专家来解决问题.例如Linux,它是一个非常复杂的系统,因此需要成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ5D0z.html" rel="bookmark" class="title">csv文件导入到数据库-怎么把淘宝csv文件图片全部提出到本地</a>
					<div>
						问题描述 怎么把淘宝csv文件图片全部提出到本地 把淘宝.csv文件全部图片提取到本地.再淘宝助理上传到自己的淘宝空间里. 解决方案 写代码,把图片URL从CSV文件里面提取出来,然后用程序下载这些图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2YZEb.html" rel="bookmark" class="title">那些让人不得不吐槽的软件设计风格</a>
					<div>
						[TechWeb报道]相信IT迷们都会发现无论是iOS 7还是最新的Android L,其设计风格都越来越类似,而著名科技外媒Arstechnica就集合了一些员工开了次吐槽大会,对当今软件设计中他们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7DwJp.html" rel="bookmark" class="title">随笔&mdash;&mdash;初学编程，急而不慌</a>
					<div>
						晚上看学生的博客.刚学几周C++的同学,水平差别已经相当大了.前两年的差别没有这么大,刚起步,投入多少直接决定了感觉是否能来.为一些同学的状态着急,初入大学的懈怠期何时才能出来?! 一位同学发来了私信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32xrAz.html" rel="bookmark" class="title">世界第一的激光雷达企业如何造就？看 Velodyne 与 David Hall 的技术人生</a>
					<div>
						&quot;在我的整个职业生涯里,从来没有为人打工,也从不需要向任何人报告.我年纪已不小,现在要改变已经迟了.如果任何人想着做我的老板--还是死了这条心.但我有董事会.这是个新奇的体验,我还算是享受, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/MlQ6Jqp.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2VnbWVudGZhdWx0LmNvbS9pbWFnZT9zcmM9aHR0cDovL3NlYW4taW1hZ2VzLnFpbml1ZG4uY29tL3Ztd2FyZS1jb252ZXJ0ZXItMC5wbmcmYW1wO29iamVjdElkPTExOTAwMDAwMDI2OTc5MjkmYW1wO3Rva2VuPTVkYWVjYzQwN2NmYjNmNWZkNmZmODNhYTY0ZDQwNjNl.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/MlQ6Jqp.html" rel="bookmark" class="title">使用vmware vconverter从物理机迁移系统到虚拟机P2V（多图）</a>
					<div>
						本文完整记录了如何从物理服务器,保持所有环境配置信息,纹丝不动的迁移到虚拟机上,俗称 P2V .采用的工具是VMware公司的VMware vcenter vconverter standalone, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7G7AM.html" rel="bookmark" class="title">《例说51单片机（C语言版）（第3版）》&mdash;&mdash;1-5 MCS-51的开发流程与工具</a>
					<div>
						1-5 MCS-51的开发流程与工具 例说51单片机(C语言版)(第3版) 8x51系统的开发流程与一般单片机微控制器的开发流程类似,其基本开发流程可分为软件与硬件两部分,而这两部分可以并行开发.在硬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvml75b.html" rel="bookmark" class="title">iostream-C&plus;&plus;输入输出流和循环的问题</a>
					<div>
						问题描述 C++输入输出流和循环的问题 #include&lt;iostream&gt; using namespace std; int main() { int n=1; while(n){ co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5vJeM.html" rel="bookmark" class="title">微软宣布推出Microsoft Azure Preview Portal</a>
					<div>
						Build 2014开发者大会的第二日,微软公布推出了Microsoft Azure Preview Portal--首个业界能跨平台整合技术.服务和工具的云环境,能够让开发者和企业快速实现的云开发创 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1264rp.html" rel="bookmark" class="title">Facebook Q2营收超华尔街预期</a>
					<div>
						网易科技讯 7月24日消息,据路透社报道,Facebook今天发布的2014年第二季度财报显示,受益于快速增长的移动广告业务,该公司第二季度的营收同比增长了61%,超出华尔街分析师预期,并使其股价在周 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqY9vp.html" rel="bookmark" class="title">php jsp共享session</a>
					<div>
						问题描述 将jsp的数据对象放入到session,php在想办法拿到这个session,知道的高手们加我qq737120695或直接发送到我的有些chengc2281@126.com(最好带例子php ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXoYlb.html" rel="bookmark" class="title">华联股份华联综超关联款乱象均涉嫌虚假陈述？</a>
					<div>
						近日,有投资者反映,华联综超(行情,资讯)(600361.SH)与华联股份(行情,资讯)(000882.SZ)相互披露的应收应付款项存在蹊跷. 华联综超半年报披露,截至上半年,公司其他应收华联股份12 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0E4Vp.html" rel="bookmark" class="title">在eclipse中运行正常，生成可运行jar包，双击运行不正常  用java -jar运行正常</a>
					<div>
						问题描述 rt,谢谢啊!在eclipse中运行正常,生成可运行jar包,双击运行不正常用java-jar运行正常 解决方案 解决方案二:步骤一:打开注册表,开始-&gt;运行(或者用快捷键WIN+R) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GAN9M.html" rel="bookmark" class="title">asp&period;net C&num;的异常处理机制程序代码</a>
					<div>
						何完美的应用程序和技术高明的程序员,都不可能是绝对不出差错的.与其追求完美无错的代码,还不如将程序中可能预知的异常在发布前进行很好的处理,可能是最有价值的.那么,C#是如何处理异常的呢?首先,我们从最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wZWZz.html" rel="bookmark" class="title">盘点物联网网络和设备安全的五个误解</a>
					<div>
						物联网(loT)正在迅猛发展,当越来越多的联网设备在家庭和商业等方面的广泛应用,据估计,到2020年,全球范围内将会部署300亿台联网设备,全球物联网正在迅速发展,而这给企业带来全新威胁. 物联网(I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdXGQM.html" rel="bookmark" class="title">《冒险岛》机械师加点攻略早知道</a>
					<div>
						创造了韩国41.6万同时在线奇迹的2010年韩国第一网游冒险岛&lt;大巨变&gt;12月28日在国内进行开放测试后人气爆棚,区区爆满,在线人数疯狂飙升!现在更加爱激动人心的时刻就要来临了!1月18日 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0vWEM.html" rel="bookmark" class="title">nagios监控单网卡双IP</a>
					<div>
						公司的业务有几台服务器存放在IDC机房中,说是双线路.但是我看到网卡的配置是单网卡双IP的形式.如下: 而公司这边的线路是联通的IP,如下: nagios监控搭建在公司内部,由于南北线路联通的问题.导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnO3ZAz.html" rel="bookmark" class="title">&lpar;求助&rpar;关于连接数据源的问题</a>
					<div>
						问题描述 我想给通过中间层给控件配置数据源但是发现选择好业务对象和方法后确显示不出调用结果请高手指教 解决方案 解决方案二:页面层没有引用中间层吧					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
